Attribute VB_Name = "Funcao43"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'O cdigo abaixo busca a hora e a data de um computador da rede

Private Declare Function NetRemoteTOD Lib "NETAPI32.DLL" (ByVal server As String, buffer As Any) As Long
Private Declare Function NetApiBufferFree Lib "NETAPI32.DLL" (ByVal buffer As Long) As Long
Private Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Type TIME_OF_DAY
    t_elapsedt As Long
    t_msecs As Long
    t_hours As Long
    t_mins As Long
    t_secs As Long
    t_hunds As Long
    t_timezone As Long
    t_tinterval As Long
    t_day As Long
    t_month As Long
    t_year As Long
    t_weekday As Long
End Type


' Funo para retornar a Data/Hora de um computador na rede
'   RETORNO:
'     string no formato dd/mm/yyyy-hh:mm:ss
'   PARAMETROS:
'     sComputador: Nome de um computador da rede. Ex: \\SERVIDOR1

Public Function BuscarDataHora(sComputador As String) As String

   Dim sRetorno  As String
   Dim todTime   As TIME_OF_DAY
   Dim ptrTime   As Long
   Dim lRetorno  As Long
   Dim sServidor As String
   Dim dRemoto   As Date

   On Error GoTo ERRO

   sRetorno = ""
   Screen.MousePointer = vbHourglass

   sServidor = StrConv(sComputador, vbUnicode)
   lRetorno = NetRemoteTOD(sServidor, ptrTime)
   If lRetorno = 0 Then
      CopyMemory todTime, ByVal ptrTime, Len(todTime) 'COPIA O PONTEIRO RETORNADO PARA A ESTRUTURA TIME_OF_DAY
      dRemoto = DateSerial(70, 1, 1) + (todTime.t_elapsedt / 60 / 60 / 24)   'CONVERTE O TEMPO DECORRIDO DESDE 1/Jan/70 PARA UMA DATA
      dRemoto = dRemoto - (todTime.t_timezone / 60 / 24)  'AJUSTAR PARA DIFERENAS DO TimeZone
      sRetorno = Format(dRemoto, "dd/mm/yyyy") & "-" & Format(dRemoto, "hh:mm:ss")
      NetApiBufferFree (ptrTime) 'LIBERA O PONTEIRO DA MEMRIA
   Else
     'Erro 53: servidor no encontrado
       MsgBox "No pode encontrar o servidor." & vbCrLf & vbCrLf & sServidor, vbExclamation, "Ateno"
   End If

   GoTo FIM

ERRO:
   MsgBox Err.Number & vbCrLf & Err.Description, vbCritical, "Erro"

FIM:
   Screen.MousePointer = vbDefault
   BuscarDataHora = sRetorno
   Exit Function

End Function

