Attribute VB_Name = "Funcao61"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'Esta funo localiza qualquer tipo de arquivo no seu HD
'Mas s localiza se indicar a extenso do arquivo, por exemplo, *.bmp, *.bat etc...

Private Const MAX_PATH = 260
Public ArquivosLoc As New Collection
Private Const UnicodeTypeLib = True

Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
End Type

Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal sDrive As String) As Long
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As String) As Long

'Utilize esta funo para localizar o arquivo que voc quizer

'Na propriedade INICIARDRIVE apenas indique a letra do drive que deseja localizar o
'arquivo que voc quer, por exemplo, se quizer pesquisar no drive C:, digite apenas
' "C" no precisa digitar os dois pontos.

'Vamos supor que eu queira localizar todos os arquivos com a extenso BMP, seria:
'Call LocalizarArquivo("*.bmp", "c")

'S isso. Depois para saber quais os arquivos localizados utilize as propriedades da
'varivel ARQUIVOSLOC

Public Sub LocalizarArquivo(TipoArquivo As String, IniciarDrive As String)
    Dim DriveInicio As String
    DriveInicio = IniciarDrive & ":\"
    
    Set ArquivosLoc = FindFiles(TipoArquivo, DriveInicio)
End Sub


Public Function FindFiles(sTarget As String, Optional ByVal Start As String) As Collection

Dim ab() As Byte
Static TypeDrev As String
Dim hFiles As Long, f As Boolean
Static sName As String, sSpec As String, nFound As New Collection
Static fd As WIN32_FIND_DATA, iLevel As Long
Dim sEmpty, INVALID_HANDLE_VALUE

If Start = sEmpty Then Start = CurDir$
    If iLevel = 0 Then
        Set nFound = Nothing
        Start = NormalizePath(Start)
    End If
    iLevel = iLevel + 1
    hFiles = FindFirstFile(Start & "*.*", fd)
    f = (hFiles <> INVALID_HANDLE_VALUE)
    Do While f
        ab = fd.cFileName
        sName = ByteZToStr(ab)
        If left$(sName, 1) <> "." Then
            sSpec = Start & sName
            If fd.dwFileAttributes And vbDirectory Then
                DoEvents
                FindFiles sTarget, sSpec & "\"
            Else
                If InStr(sTarget, "*") > 0 Then
                    If StrComp(Right$(sName, 3), Right$(sTarget, 3), 1) = 0 Then

                    nFound.Add sSpec
                ElseIf StrComp(sName, sTarget, 1) = 0 Then
                    nFound.Add sSpec
                End If
            End If
        End If
    End If
    f = FindNextFile(hFiles, fd)
    Loop
f = FindClose(hFiles)

Set FindFiles = nFound
iLevel = iLevel - 1

End Function
Function ByteZToStr(ab() As Byte) As String
    If UnicodeTypeLib Then
        ByteZToStr = ab
    Else
        ByteZToStr = StrConv(ab, vbUnicode)
    End If
    ByteZToStr = left$(ByteZToStr, lstrlen(ByteZToStr))
End Function

Function NormalizePath(sPath As String) As String
    If Right$(sPath, 1) <> "\" Then
        NormalizePath = sPath & "\"
    Else
        NormalizePath = sPath
    End If
End Function
