Attribute VB_Name = "Funcao73"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'Esta funo cria um efeito de dissolvio de
'imagens em uma picturebox, um efeito muito bom.

'Para us-la adicione em seu form 2 picturebox
'Uma deve estar a imagem que ser mostrada aps
'a execuo do efeito, e na outra a imagem a
'ser substituda aps o efeito.

'No Load do Form coloque a funo INICIAR EFEITO FIG

'No evento Paint do picturebox que ser usado
'para o efeito coloque a funo: ATIVAR EFEITO

'As outras funes so de sua escolha onde e
'quando us-las. Tem a funo que vai mostrando
'pausadamente o efeito, por exemplo, voc poderia
'colocar esta funo no click do PictureBox, a funo
' a INICIAR EFEITO FIG LENTO

'Caso queira que o efeito comece e termine de uma vez
'a funo  ATIVAR EFEITO FIG COMPLETO


Private Type BITMAPINFOHEADER
   biSize As Long
   biWidth As Long
   biHeight As Long
   biPlanes As Integer
   biBitCount As Integer
   biCompression As Long
   biSizeImage As Long
   biXPelsPerMeter As Long
   biYPelsPerMeter As Long
   biClrUsed As Long
   biClrImportant As Long
End Type

Private Type RGBQUAD
   rgbBlue As Byte
   rgbGreen As Byte
   rgbRed As Byte
   rgbReserved As Byte
End Type

Private Type BITMAPINFO
   bmiHeader As BITMAPINFOHEADER
   bmiColors(1) As RGBQUAD
End Type

Private PixelSetSequence(64) As Integer
Private Const NumberOfSteps = 8
Private hBrush As Variant
Private DissolveStep As Integer


Private Declare Function CreateDIBitmap Lib "gdi32" (ByVal hDC As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, ByVal lpInitBits As String, lpInitInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Private Declare Function StretchBlt% Lib "gdi32" Alias "StretchBlt%" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal nSrcWidth%, ByVal nSrcHeight%, ByVal dwRop&)
Private Declare Function CreatePatternBrush Lib "gdi32" (ByVal hBitmap As Long) As Long

Private Const SRCCOPY = &HCC0020
Private Const SRCPAINT = &HEE0086
Private Const SRCAND = &H8800C6
Private Const SRCINVERT = &H660046
Private Const SRCERASE = &H440328
Private Const NOTSRCCOPY = &H330008
Private Const NOTSRCERASE = &H1100A6
Private Const MERGECOPY = &HC000CA
Private Const MERGEPAINT = &HBB0226
Private Const PATCOPY = &HF00021
Private Const PATPAINT = &HFB0A09
Private Const PATINVERT = &H5A0049
Private Const DSTINVERT = &H550009
Private Const BLACKNESS = &H42&
Private Const WHITENESS = &HFF0062
Private Const BLACKONWHITE = 1
Private Const WHITEONBLACK = 2
Private Const COLORONCOLOR = 3
Private Const BI_RGB = 0&
Private Const BI_RLE8 = 1&
Private Const BI_RLE4 = 2&
Private Const TRANSPARENT = 1
Private Const OPAQUE = 2

Private Const CBM_INIT = &H4&

Private Const DIB_RGB_COLORS = 0
Private Const DIB_PAL_COLORS = 1
Private PixelBase(1 To 64) As Integer

Private Function CreateDissolveBrush(DissolveStep As Integer, Figura As PictureBox) As Integer
Dim hCompBitmap As Long
Dim BrushBitmapInfo As BITMAPINFO
Dim Counter As Integer
Dim PixelData As String * 32
Dim Dummy As Long
Dim Row As Integer
Dim Column As Integer

   With BrushBitmapInfo.bmiHeader
      .biSize = 40
      .biWidth = 8
      .biHeight = 8
      .biPlanes = 1
      .biBitCount = 1
      .biCompression = 0
      .biSizeImage = 0
      .biXPelsPerMeter = 0
      .biYPelsPerMeter = 0
      .biClrUsed = 0
      .biClrImportant = 0
   End With

   ' Set the color table values for
   ' the brush to black and white.
   With BrushBitmapInfo.bmiColors(0)
      .rgbBlue = 0
      .rgbGreen = 0
      .rgbRed = 0
      .rgbReserved = 0
   End With
   With BrushBitmapInfo.bmiColors(1)
      .rgbBlue = 255
      .rgbGreen = 255
      .rgbRed = 255
      .rgbReserved = 0
   End With

   ' Initialize brush bitmap pixel data to all white.
   For Counter = 0 To 7
      Mid$(PixelData, Counter * 4 + 1, 1) = Chr$(&HFF)
   Next Counter

   ' Set the bits representing the black pixels to 0.
   For Counter = 1 To DissolveStep * (64 / NumberOfSteps)
      Row = (PixelSetSequence(Counter) - 1) \ 8
      Column = (PixelSetSequence(Counter) - 1) Mod 8
      Mid$(PixelData, Row * 4 + 1, 1) = Chr$(Asc(Mid$(PixelData, Row * 4 + 1, 1)) And (Not (2 ^ Column)))
   Next Counter

   '  Convert the DIB into a DDB and create the pattern brush.
   hCompBitmap = CreateDIBitmap(Figura.hDC, BrushBitmapInfo.bmiHeader, CBM_INIT, PixelData, BrushBitmapInfo, DIB_RGB_COLORS)
   CreateDissolveBrush = CreatePatternBrush(hCompBitmap)
   Dummy = DeleteObject(hCompBitmap)
End Function


Private Sub CreatePixelSetSequence()
Dim Counter As Integer
Dim PixelNumberString As String * 5
Const PixelListFile = 1

PixelSetSequence(1) = 1
PixelSetSequence(2) = 5
PixelSetSequence(3) = 33
PixelSetSequence(4) = 37
PixelSetSequence(5) = 19
PixelSetSequence(6) = 23
PixelSetSequence(7) = 51
PixelSetSequence(8) = 55
PixelSetSequence(9) = 17
PixelSetSequence(10) = 21
PixelSetSequence(11) = 49
PixelSetSequence(12) = 53
PixelSetSequence(13) = 3
PixelSetSequence(14) = 7
PixelSetSequence(15) = 35
PixelSetSequence(16) = 39
PixelSetSequence(17) = 10
PixelSetSequence(18) = 14
PixelSetSequence(19) = 42
PixelSetSequence(20) = 46
PixelSetSequence(21) = 28
PixelSetSequence(22) = 32
PixelSetSequence(23) = 60
PixelSetSequence(24) = 64
PixelSetSequence(25) = 26
PixelSetSequence(26) = 30
PixelSetSequence(27) = 58
PixelSetSequence(28) = 62
PixelSetSequence(29) = 12
PixelSetSequence(30) = 16
PixelSetSequence(31) = 44
PixelSetSequence(32) = 48
PixelSetSequence(33) = 8
PixelSetSequence(34) = 4
PixelSetSequence(35) = 40
PixelSetSequence(36) = 36
PixelSetSequence(37) = 22
PixelSetSequence(38) = 18
PixelSetSequence(39) = 54
PixelSetSequence(40) = 50
PixelSetSequence(41) = 24
PixelSetSequence(42) = 20
PixelSetSequence(43) = 56
PixelSetSequence(44) = 52
PixelSetSequence(45) = 6
PixelSetSequence(46) = 2
PixelSetSequence(47) = 38
PixelSetSequence(48) = 34
PixelSetSequence(49) = 15
PixelSetSequence(50) = 11
PixelSetSequence(51) = 47
PixelSetSequence(52) = 43
PixelSetSequence(53) = 29
PixelSetSequence(54) = 25
PixelSetSequence(55) = 61
PixelSetSequence(56) = 57
PixelSetSequence(57) = 31
PixelSetSequence(58) = 27
PixelSetSequence(59) = 63
PixelSetSequence(60) = 59
PixelSetSequence(61) = 13
PixelSetSequence(62) = 9
PixelSetSequence(63) = 45
PixelSetSequence(64) = 41

'   Open App.Path & "\PixelLst.TXT" For Input As #PixelListFile
'   For Counter = 1 To 64
'      Input #PixelListFile, PixelNumberString
'      PixelSetSequence(Counter) = Val(PixelNumberString)
'   Next Counter
End Sub

Public Sub IniciarEfeitoFig()
   Call CreatePixelSetSequence
   DissolveStep = 0#
End Sub

Public Sub AtivarEfeito(gPictureOriginal As PictureBox, gPictureFinal As PictureBox)
Dim hRgn As Long
Dim Dummy As Long
Dim hOldBrush As Long

   hBrush = CreateDissolveBrush(DissolveStep, gPictureOriginal)
   hOldBrush = SelectObject(gPictureFinal.hDC, hBrush)
   Dummy = BitBlt(gPictureFinal.hDC, 0, 0, gPictureFinal.ScaleWidth, gPictureFinal.ScaleHeight, gPictureOriginal.hDC, 0, 0, &HAC0744)
   'Dummy = StretchBlt%(Picture2.hDC, 0, 0, Picture2.ScaleWidth, Picture2.ScaleHeight, Picture1.hDC, 0, 0, Picture2.ScaleWidth, Picture2.ScaleHeight, &HAC0744)
   Dummy = SelectObject(gPictureFinal.hDC, hOldBrush)
   Dummy = DeleteObject(hBrush)
End Sub

Public Sub IniciarEfeitoFigLento(gPictureOriginal As PictureBox, gPictureFinal As PictureBox)

   If DissolveStep < NumberOfSteps Then
      DissolveStep = DissolveStep + 1
      Call AtivarEfeito(gPictureOriginal, gPictureFinal)
   End If
End Sub

Public Sub AtivarEfeitoFigCompleto(gPictureOriginal As PictureBox, gPictureFinal As PictureBox, TempoEfeito As Single)

Dim Tempo As Single

Do
   If DissolveStep < NumberOfSteps Then
      DissolveStep = DissolveStep + 1
      For Tempo = 1 To TempoEfeito
      DoEvents
      Next
      Call AtivarEfeito(gPictureOriginal, gPictureFinal)
   Else
      Exit Do
   End If
Loop While DissolveStep <= NumberOfSteps
End Sub

