Attribute VB_Name = "Funcao86"
Option Explicit

'As funes abaixo, adaptadas por mim,
'fazem vrios processos com imagens.

'**********************************************
'Este ENUM  utilizado na funo que
'd flips em imagens
Public Enum OpcoesFlips
    Horizontal = 1
    Vertical = 2
    Both = 3
End Enum

'**********************************************
'Estas variveis so usadas na funo
'que aplica efeitos especiais  imagens
Private ImagePixels(0 To 2, 0 To 500, 0 To 500) As Integer
Private X As Integer, Y As Integer

Public Enum imgOpcoesEfeitos
    Smooth = 1
    Sharpen = 2
    Emboss = 3
    Diffuse = 4
    Solarise = 5
    LerPixels = 6
End Enum
'**********************************************

'Para utilizar esta funo deve colocar um
'PictureBox com a imagem original e outro
'picturebox para receber o efeito
Public Sub FlipImagens(fiOpcoes As OpcoesFlips, gPictureBox1 As PictureBox, gPictureBox2 As PictureBox)

    Select Case fiOpcoes
        Case 1  'flip HORIZONTAL
            gPictureBox2.PaintPicture gPictureBox1.Picture, _
            0, 0, gPictureBox1.ScaleWidth, _
            gPictureBox1.ScaleHeight, gPictureBox1.ScaleWidth, _
            0, -gPictureBox1.ScaleWidth, gPictureBox1.ScaleHeight, &HCC0020
        
        Case 2  'flip VERTICAL
            gPictureBox2.PaintPicture gPictureBox1.Picture, _
            0, 0, gPictureBox1.ScaleWidth, _
            gPictureBox1.ScaleHeight, 0, gPictureBox1.ScaleHeight, _
            gPictureBox1.ScaleWidth, -gPictureBox1.ScaleHeight, &HCC0020
        
        Case 3 'flips HORIZONTAL E VERTICAL
            gPictureBox2.PaintPicture gPictureBox1.Picture, 0, 0, _
            gPictureBox1.ScaleWidth, gPictureBox1.ScaleHeight, _
            gPictureBox1.ScaleWidth, gPictureBox1.ScaleHeight, _
            -gPictureBox1.ScaleWidth, -gPictureBox1.ScaleHeight, &HCC0020
    End Select
    
End Sub

'Esta funo s funcionar em uma PICTUREBOx
'Para que os efeitos funcionem  necessrio
'que toda vez que voc abrir uma figura no
'picturebox voc mande a funo ler os pixels com a opo LERPIXELS

'As funes abaixo no funcionam com imagens muito grandes
'O mximo  mais ou menos 500Kb

Public Sub EfeitosImagens(efiOpcoes As imgOpcoesEfeitos, gPicture As PictureBox)

    Dim i As Integer, j As Integer
    Dim red As Integer, green As Integer, blue As Integer
    Dim Rx As Integer, Ry As Integer
    Dim pixel As Long
    
Select Case efiOpcoes
    Case 1  'Smooth
        For i = 1 To Y - 2
            For j = 1 To X - 2
                red = ImagePixels(0, i - 1, j - 1) + ImagePixels(0, i - 1, j) + _
                ImagePixels(0, i - 1, j + 1) + ImagePixels(0, i, j - 1) + _
                ImagePixels(0, i, j) + ImagePixels(0, i, j + 1) + _
                ImagePixels(0, i + 1, j - 1) + ImagePixels(0, i + 1, j) + _
                ImagePixels(0, i + 1, j + 1)
            
                green = ImagePixels(1, i - 1, j - 1) + ImagePixels(1, i - 1, j) + _
                ImagePixels(1, i - 1, j + 1) + ImagePixels(1, i, j - 1) + _
                ImagePixels(1, i, j) + ImagePixels(1, i, j + 1) + _
                ImagePixels(1, i + 1, j - 1) + ImagePixels(1, i + 1, j) + _
                ImagePixels(1, i + 1, j + 1)
            
                blue = ImagePixels(2, i - 1, j - 1) + ImagePixels(2, i - 1, j) + _
                ImagePixels(2, i - 1, j + 1) + ImagePixels(2, i, j - 1) + _
                ImagePixels(2, i, j) + ImagePixels(2, i, j + 1) + _
                ImagePixels(2, i + 1, j - 1) + ImagePixels(2, i + 1, j) + _
                ImagePixels(2, i + 1, j + 1)

                gPicture.PSet (j, i), RGB(red / 9, green / 9, blue / 9)
            Next
            gPicture.Refresh
        Next
    
    Case 2  'sharpen
        Const Dx As Integer = 1
        Const Dy As Integer = 1
    
        For i = 1 To Y - 2
            For j = 1 To X - 2
                red = ImagePixels(0, i, j) + 0.5 * (ImagePixels(0, i, j) - _
                    ImagePixels(0, i - Dx, j - Dy))
                green = ImagePixels(1, i, j) + 0.5 * (ImagePixels(1, i, j) - _
                    ImagePixels(1, i - Dx, j - Dy))
                blue = ImagePixels(2, i, j) + 0.5 * (ImagePixels(2, i, j) - _
                    ImagePixels(2, i - Dx, j - Dy))
                
                If red > 255 Then red = 255
                If red < 0 Then red = 0
                If green > 255 Then green = 255
                If green < 0 Then green = 0
                If blue > 255 Then blue = 255
                If blue < 0 Then blue = 0
                
                gPicture.PSet (j, i), RGB(red, green, blue)
            Next
            gPicture.Refresh
        Next
    
    Case 3  'emboss
        For i = 1 To Y - 2
            For j = 1 To X - 2
                red = Abs(ImagePixels(0, i, j) - ImagePixels(0, i + Dx, j + Dy) + 128)
                green = Abs(ImagePixels(1, i, j) - ImagePixels(1, i + Dx, j + Dy) + 128)
                blue = Abs(ImagePixels(2, i, j) - ImagePixels(2, i + Dx, j + Dy) + 128)
                gPicture.PSet (j, i), RGB(red, green, blue)
            Next
            gPicture.Refresh
        Next
    
    Case 4  'diffuse
        For i = 2 To Y - 3
            For j = 2 To X - 3
                Rx = Rnd() * 4 - 2
                Ry = Rnd() * 4 - 2
                red = ImagePixels(0, i + Rx, j + Ry)
                green = ImagePixels(1, i + Rx, j + Ry)
                blue = ImagePixels(2, i + Rx, j + Ry)
                gPicture.PSet (j, i), RGB(red, green, blue)
            Next
            DoEvents
        Next
    
    Case 5  'solarise
        For i = 1 To Y - 2
            For j = 1 To X - 2
                red = ImagePixels(0, i, j)
                green = ImagePixels(1, i, j)
                blue = ImagePixels(2, i, j)
                If ((red < 128) Or (red > 255)) Then red = 255 - red
                If ((green < 128) Or (green > 255)) Then green = 255 - green
                If ((blue < 128) Or (blue > 255)) Then blue = 255 - blue
                gPicture.PSet (j, i), RGB(red, green, blue)
            Next
            DoEvents
        Next
        gPicture.Refresh
    
    Case 6  'Fazer leitura dos pixels
        X = gPicture.ScaleWidth
        Y = gPicture.ScaleHeight
        If X > 500 Or Y > 500 Then
            MsgBox "A Imagem  muito grande para completar a opo."
            X = 0
            Y = 0
            Exit Sub
        End If
        
        For i = 0 To Y - 1
            For j = 0 To X - 1
                pixel = gPicture.Point(j, i)
                red = pixel Mod 256
                green = ((pixel And &HFF00) / 256&) Mod 256&
                blue = (pixel And &HFF0000) / 65536
                ImagePixels(0, i, j) = red
                ImagePixels(1, i, j) = green
                ImagePixels(2, i, j) = blue
            Next
        Next
        MsgBox "Leitura Finalizada com Sucesso!!!"
End Select

End Sub
